/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   ADC
******************************************************************************/

#include "ADC.h"

/************************************************
;  *    @            : ADC_ZERO
;  *    @˵              : ADCƫУ׼
;  *    @          :
;  *    @ز          :
;  ***********************************************/
char ADC_ZERO(void)
{
    ADCCR0 = 0xFD;                 //ʹADCڲ2VGNDͨ
    ADCCR1 = 0x42;                 //12λH8L416Ƶ8ADCLK
    ADCCR3 = 0x01;
    OSADJCR |= DEF_SET_BIT7;       //ʹУ׼޵
    CLR_GODONE();
    while (!(ADCCR0 & 0x02));
    if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
    {
        OSADJCR |= DEF_SET_BIT6;   //޵
        OSADJCR |= 0x3F;
        CLR_GODONE();
        while (!(ADCCR0 & 0x02));
        if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
        {
            CLR_ADEN();
            return 0;
        }
        else
        {
            while (1)
            {
                if (OSADJCR & 0x3F)
                {
                    OSADJCR--;
                    CLR_GODONE();
                    while (!(ADCCR0 & 0x02));
                    if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
                    {
                        CLR_ADEN();
                        return 0;
                    }
                }
                else
                {
                    CLR_ADEN();
                    return 1;
                }
            }
        }
    }
    else
    {
        while (1)
        {
            if ((OSADJCR & 0x3F) == 0x3F)
            {
                CLR_ADEN();
                return 1;
            }
            else
            {
                OSADJCR++;
                CLR_GODONE();
                while (!(ADCCR0 & 0x02));
                if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
                {
                    CLR_ADEN();
                    return 0;
                }
            }
        }
    }
}


/************************************************
;  *    @            : ADC_Init
;  *    @˵              : ADCʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void ADC_Init(void)
{
    ADCCR0 = 0x0C;        //ڲ2V
    ADCCR1 = 0x42;        //12λH8L416Ƶ8ADCLK
    ADCCR2 = 0x00;
    ADCCR3 = 0x01;        //ʹVREF,PGA1
    ADCCR0 |= 0x01;       //ʹADC
}
/****  ͨѡ  ***/
void ADC_ADCHS(uint8_t CH)
{
    ADCCR0 &=~ 0xF0;
    ADCCR0 |=  CH;
}
/****  ADɼ  ***/
uint16_t ADC_Get_FlagStatus(void)
{
    uint16_t temp;
    CLR_GODONE();          //ת
    // ADC_FLAG = 1;
    while (!(ADCCR0 & 0x02));
    temp = 0;
    temp = ADRH << 4;
    temp += ADRL;
    return temp;
}
/************************************************
;  *    @            : ADC_Get_Value
;  *    @˵              : ADɼ
;  *    @          : CH
;  *    @ز          :
;  ***********************************************/
uint16_t ADC_Get_Value(uint8_t CH)
{
    uint8_t channel = 0;
    uint32_t tmpBuff = 0;
    uint16_t AdcMAX = 0;
    uint16_t AdcMIN = 0xffff;
    uint16_t temp_value = 0;
    ADC_ADCHS(CH);                  //ͨѡ
    for (channel = 0; channel < 20; channel++)
    {
        temp_value = ADC_Get_FlagStatus();
        if (channel < 2)
            continue;                 //ǰβֵ
        if (temp_value > AdcMAX)
            AdcMAX = temp_value;      //
        if (temp_value < AdcMIN)
            AdcMIN = temp_value;      //С
        tmpBuff += temp_value;
    }
    tmpBuff -= AdcMAX;              //ȥһ
    tmpBuff -= AdcMIN;              //ȥһС
    temp_value = (tmpBuff >> 4);    //16,ȡƽֵ
    return temp_value;
}
