/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                IIC_24C02
;  *           MCU 16MHz
;  *           Կʹ[DIO1(P15),CLK1(P16)]
;  *           24C02дٻضضɹLED1LED2
;  *           ޸AT24C02_Read_ModeAT24C02_Write_ModeԸıдʽ
;  *           Ϣ,9600(UART.h),TX P23
;  *           IIC_SCL:P11D,IIC_SDA:P12D;24c02Ӧź,ڲ鿴.
******************************************************************************/

#include "user.h"
#include "intrins.h"

__O Flag flag1;

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main(void)
{
    uint16_t test_result =0 ;
    DISABLE_GIE();           //رж
    OSCSS &= ~0x70;
    GPIO_Init();
    IIC_Init();
    UART0_Init();
    ENABLE_GIE();            //ж
    while (1)
    {
        test_result = simIIC_EEPROM_Test();
        if( test_result ) 
        {
            LED1 = 1;LED2 = 0;
        }
        else 
        {
            LED1 = 0;LED2 = 1;
        }
    }
}