/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *              PWM1ģʽ & ģʽ
;  *              Fsys = 16MHz
******************************************************************************/

#include "PWM.h"

/************************************************
;  *    @            : PWM1_Init
;  *    @˵              : PWM1ʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void PWM1_Init(void)
{
    PWM1RLEN = 0x55;              //Ᵽ޸ PWM ܱĴ
    PWM1OE = 0x3f;                // 6  I/O Ϊ PWM 
    PWM1CR0 = 0x0C;               //PWM ʱѡϵͳʱӣñضģʽ8Ƶ
    PWM1CR1 = 0x00;               

    PWM1PL = 0xE8;                //Fsys=1MHz ,PWM Ϊ 1000 Fsysclk,500us
    PWM1PH = 0x03;
    PWM1FBCR = 0x38;              //ѡɲź1͵ƽЧ˲ʱ䳣4us
  
#if (PWM1_Mode == 1)              //ģʽ
    PWM1CR1 = 0x00;               //ģʽ
    PWM1CR2 = 0x00;
    PWM1DT0 = 0x02;              // ʱΪ 2 Fsys clk

    PWM1ADL = 0x90;               //PWM1A ռձΪ 40%
    PWM1ADH = 0x01;
    PWM1BDL = 0xF4;               //PWM1B ռձΪ 50%
    PWM1BDH = 0x01;
    PWM1CDL = 0x58;               //PWM1C ռձΪ 60%
    PWM1CDH = 0x02;
#endif
  
#if (PWM1_Mode == 2)              //ģʽ
    PWM1CR1  = 0x38;              //ģʽ ռձڼߵƽ
    PWM1ADL  = 0x64;              //PWM1A ռձΪ 10%
    PWM1ADH  = 0x00;
    PWM1BDL  = 0x2C;              //PWM1B ռձΪ 30%
    PWM1BDH  = 0x01;
    PWM1CDL  = 0xBC;              //PWM1C ռձΪ 70%
    PWM1CDH  = 0x02;
#endif

    PWM1IE |= DEF_SET_BIT6;       //PWM ƥж
    PWM1OE |= DEF_SET_BIT7;       // PWM ʱ
    IEN1 = DEF_SET_BIT5 | DEF_SET_BIT2 ;          //ʹɲPWM1ж
    PWM1RLEN = 0xAA;                             //أ PWM ļĴֵ루ڣռձȣȣ  
}

void PWM1_ISR(void) interrupt PWM1_IRQn
{
    PWM1IF &=~ DEF_SET_BIT6;                     //жϱ־
    LED1=!LED1;
}

void PWM1FB_ISR(void) interrupt PWM1FB_IRQn      //ɲж
{
    LED2 =! LED2;
		PWM1RLEN = 0x55;
    PWM1FBCR = 0x38;                            //жϱ־
	  PWM1RLEN = 0xAA;
}
