/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                        WDT_Reset
;  *               û֡ѡʼʹWDT
;  *               мWDTλ־
;  *               δWDTλʱLED1(P00D) T0 1msжȡ
;  *               ϵ1024msWDTλ
;  *               WDTλ־λWDTֹT0жϡ
******************************************************************************/

#include "user.h"

void WDT_Reset_Timer(WDT_RST_TIME rset_time)
{
    WDTCR = rset_time;
}
/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/

void main(void)
{
    DISABLE_GIE();
    OSCSS &= 0x80;
    OSCSS |= 0x40;           //16ƵFsys=32/2/16
    GPIO_Init();
    Timer0_Init();
    ENABLE_GIE();
    WDT_Reset_Timer(WDT_TIME_SET_1024MS);             //1024ms
    while(1)
    {
        if((RSTFLAG & DEF_SET_BIT4) == DEF_SET_BIT4)
        {
            RSTFLAG &=~ DEF_SET_BIT4;
            WDT_Reset_Timer(WDT_TIME_SET_256MS);      //WDT
            T0IE = 0;                                 //رT0ж
        }
    }
}
