/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                   UART ʣ9600
;  *                   UART TX -- P23D
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @            : UART0_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART0_Init(void)
{
    PCON |= DEF_SET_BIT4;         //ʹUART0
    SCON2 = 0x08;                 //TX0ЧTX0-P23,RX0-P22
    SCON0 &= 0x3e;
    SCON0 |= 0x50;                //ʽ1  
    BRGCR |= DEF_SET_BIT7;
    BRGH = band_CntH;
    BRGL = band_CntL;
    IEN1 |= DEF_SET_BIT3;         //UART0ж
}

/************************************************
;  *    @            : putchar
;  *    @˵              : ڷ
;  *    @          : tx_data
;  *    @ز          :
;  ***********************************************/
char putchar(char tx_data)
{
    SBUF0 = tx_data;              //дݵUARTݼĴ
    while (!(SCON0 & 0x02));      //ȴǰݷ
    SCON0 &= ~DEF_SET_BIT1;
    return tx_data;
}

void UART0_ISR(void) interrupt UART0_IRQn
{
    if(((SCON0 & DEF_SET_BIT0) == DEF_SET_BIT0))
    {
        SCON0 &= ~DEF_SET_BIT0;
    }
}