/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                                                            
******************************************************************************/
#ifndef GPIO_H__
#define GPIO_H__

#include "user.h"

#define LED1  P00D
#define LED2  P01D
#define KEY  P10D

/************** ģʽ ***********/
#define P00_INPUT_MODE    P0MOD0&=~DEF_SET_BIT1;P0MOD0&=~DEF_SET_BIT0;
#define P01_INPUT_MODE    P0MOD0&=~DEF_SET_BIT3;P0MOD0&=~DEF_SET_BIT2;

#define P10_INPUT_MODE    P1MOD0&=~DEF_SET_BIT1;P1MOD0&=~DEF_SET_BIT0;
#define P11_INPUT_MODE    P1MOD0&=~DEF_SET_BIT3;P1MOD0&=~DEF_SET_BIT2;
#define P12_INPUT_MODE    P1MOD0&=~DEF_SET_BIT5;P1MOD0&=~DEF_SET_BIT4;
#define P13_INPUT_MODE    P1MOD0&=~DEF_SET_BIT7;P1MOD0&=~DEF_SET_BIT6;
#define P14_INPUT_MODE    P1MOD1&=~DEF_SET_BIT1;P1MOD1&=~DEF_SET_BIT0;
#define P15_INPUT_MODE    P1MOD1&=~DEF_SET_BIT3;P1MOD1&=~DEF_SET_BIT2;
#define P16_INPUT_MODE    P1MOD1&=~DEF_SET_BIT5;P1MOD1&=~DEF_SET_BIT4;
#define P17_INPUT_MODE    P1MOD1&=~DEF_SET_BIT7;P1MOD1&=~DEF_SET_BIT6;

#define P20_INPUT_MODE    P2MOD0&=~DEF_SET_BIT1;P2MOD0&=~DEF_SET_BIT0;
#define P21_INPUT_MODE    P2MOD0&=~DEF_SET_BIT3;P2MOD0&=~DEF_SET_BIT2;
#define P22_INPUT_MODE    P2MOD0&=~DEF_SET_BIT5;P2MOD0&=~DEF_SET_BIT4;
#define P23_INPUT_MODE    P2MOD0&=~DEF_SET_BIT7;P2MOD0&=~DEF_SET_BIT6;
#define P24_INPUT_MODE    P2MOD1&=~DEF_SET_BIT1;P2MOD1&=~DEF_SET_BIT0;
#define P25_INPUT_MODE    P2MOD1&=~DEF_SET_BIT3;P2MOD1&=~DEF_SET_BIT2;
#define P26_INPUT_MODE    P2MOD1&=~DEF_SET_BIT5;P2MOD1&=~DEF_SET_BIT4;
#define P27_INPUT_MODE    P2MOD1&=~DEF_SET_BIT7;P2MOD1&=~DEF_SET_BIT6;


#define SET_ALL_GPIO_INPUT_MODE    P0MOD0=0x00;P1MOD0=0x00;P1MOD1=0x00;P2MOD0=0x00;P2MOD1=0x00;

/**************  ***********/
#define P00_PUSHPULL_MODE    P0MOD0&=~DEF_SET_BIT1;P0MOD0|=DEF_SET_BIT0;
#define P01_PUSHPULL_MODE    P0MOD0&=~DEF_SET_BIT3;P0MOD0|=DEF_SET_BIT2;

#define P10_PUSHPULL_MODE    P1MOD0&=~DEF_SET_BIT1;P1MOD0|=DEF_SET_BIT0;
#define P11_PUSHPULL_MODE    P1MOD0&=~DEF_SET_BIT3;P1MOD0|=DEF_SET_BIT2;
#define P12_PUSHPULL_MODE    P1MOD0&=~DEF_SET_BIT5;P1MOD0|=DEF_SET_BIT4;
#define P13_PUSHPULL_MODE    P1MOD0&=~DEF_SET_BIT7;P1MOD0|=DEF_SET_BIT6;
#define P14_PUSHPULL_MODE    P1MOD1&=~DEF_SET_BIT1;P1MOD1|=DEF_SET_BIT0;
#define P15_PUSHPULL_MODE    P1MOD1&=~DEF_SET_BIT3;P1MOD1|=DEF_SET_BIT2;
#define P16_PUSHPULL_MODE    P1MOD1&=~DEF_SET_BIT5;P1MOD1|=DEF_SET_BIT4;
#define P17_PUSHPULL_MODE    P1MOD1&=~DEF_SET_BIT7;P1MOD1|=DEF_SET_BIT6;

#define P20_PUSHPULL_MODE    P2MOD0&=~DEF_SET_BIT1;P2MOD0|=DEF_SET_BIT0;
#define P21_PUSHPULL_MODE    P2MOD0&=~DEF_SET_BIT3;P2MOD0|=DEF_SET_BIT2;
#define P22_PUSHPULL_MODE    P2MOD0&=~DEF_SET_BIT5;P2MOD0|=DEF_SET_BIT4;
#define P23_PUSHPULL_MODE    P2MOD0&=~DEF_SET_BIT7;P2MOD0|=DEF_SET_BIT6;
#define P24_PUSHPULL_MODE    P2MOD1&=~DEF_SET_BIT1;P2MOD1|=DEF_SET_BIT0;
#define P25_PUSHPULL_MODE    P2MOD1&=~DEF_SET_BIT3;P2MOD1|=DEF_SET_BIT2;
#define P26_PUSHPULL_MODE    P2MOD1&=~DEF_SET_BIT5;P2MOD1|=DEF_SET_BIT4;
#define P27_PUSHPULL_MODE    P2MOD1&=~DEF_SET_BIT7;P2MOD1|=DEF_SET_BIT6;


#define SET_ALL_GPIO_PUSHPULL_MODE    P0MOD0=0x55;P1MOD0=0x55;P1MOD1=0x55;P2MOD0=0x55;P2MOD1=0x55;

/**************  ***********/
#define P00_HIGH_Z_MODE    P0MOD0&=~DEF_SET_BIT0;P0MOD0|=DEF_SET_BIT1;
#define P01_HIGH_Z_MODE    P0MOD0&=~DEF_SET_BIT2;P0MOD0|=DEF_SET_BIT3;

#define P10_HIGH_Z_MODE    P1MOD0&=~DEF_SET_BIT0;P1MOD0|=DEF_SET_BIT1;
#define P11_HIGH_Z_MODE    P1MOD0&=~DEF_SET_BIT2;P1MOD0|=DEF_SET_BIT3;
#define P12_HIGH_Z_MODE    P1MOD0&=~DEF_SET_BIT4;P1MOD0|=DEF_SET_BIT5;
#define P13_HIGH_Z_MODE    P1MOD0&=~DEF_SET_BIT6;P1MOD0|=DEF_SET_BIT7;
#define P14_HIGH_Z_MODE    P1MOD1&=~DEF_SET_BIT0;P1MOD1|=DEF_SET_BIT1;
#define P15_HIGH_Z_MODE    P1MOD1&=~DEF_SET_BIT2;P1MOD1|=DEF_SET_BIT3;
#define P16_HIGH_Z_MODE    P1MOD1&=~DEF_SET_BIT4;P1MOD1|=DEF_SET_BIT5;
#define P17_HIGH_Z_MODE    P1MOD1&=~DEF_SET_BIT6;P1MOD1|=DEF_SET_BIT7;

#define P20_HIGH_Z_MODE    P2MOD0&=~DEF_SET_BIT0;P2MOD0|=DEF_SET_BIT1;
#define P21_HIGH_Z_MODE    P2MOD0&=~DEF_SET_BIT2;P2MOD0|=DEF_SET_BIT3;
#define P22_HIGH_Z_MODE    P2MOD0&=~DEF_SET_BIT4;P2MOD0|=DEF_SET_BIT5;
#define P23_HIGH_Z_MODE    P2MOD0&=~DEF_SET_BIT6;P2MOD0|=DEF_SET_BIT7;
#define P24_HIGH_Z_MODE    P2MOD1&=~DEF_SET_BIT0;P2MOD1|=DEF_SET_BIT1;
#define P25_HIGH_Z_MODE    P2MOD1&=~DEF_SET_BIT2;P2MOD1|=DEF_SET_BIT3;
#define P26_HIGH_Z_MODE    P2MOD1&=~DEF_SET_BIT4;P2MOD1|=DEF_SET_BIT5;
#define P27_HIGH_Z_MODE    P2MOD1&=~DEF_SET_BIT6;P2MOD1|=DEF_SET_BIT7;


#define SET_ALL_GPIO_HIGH_Z_MODE    P0MOD0=0xAA;P1MOD0=0xAA;P1MOD1=0xAA;P2MOD0=0xAA;P2MOD1=0xAA;

/************** ©ģʽ ***********/
#define P00_OPEN_DRAIN_MODE    P0MOD0|=DEF_SET_BIT1;P0MOD0|=DEF_SET_BIT0;
#define P01_OPEN_DRAIN_MODE    P0MOD0|=DEF_SET_BIT3;P0MOD0|=DEF_SET_BIT2;

#define P10_OPEN_DRAIN_MODE    P1MOD0|=DEF_SET_BIT1;P1MOD0|=DEF_SET_BIT0;
#define P11_OPEN_DRAIN_MODE    P1MOD0|=DEF_SET_BIT3;P1MOD0|=DEF_SET_BIT2;
#define P12_OPEN_DRAIN_MODE    P1MOD0|=DEF_SET_BIT5;P1MOD0|=DEF_SET_BIT4;
#define P13_OPEN_DRAIN_MODE    P1MOD0|=DEF_SET_BIT7;P1MOD0|=DEF_SET_BIT6;
#define P14_OPEN_DRAIN_MODE    P1MOD1|=DEF_SET_BIT1;P1MOD1|=DEF_SET_BIT0;
#define P15_OPEN_DRAIN_MODE    P1MOD1|=DEF_SET_BIT3;P1MOD1|=DEF_SET_BIT2;
#define P16_OPEN_DRAIN_MODE    P1MOD1|=DEF_SET_BIT5;P1MOD1|=DEF_SET_BIT4;
#define P17_OPEN_DRAIN_MODE    P1MOD1|=DEF_SET_BIT7;P1MOD1|=DEF_SET_BIT6;

#define P20_OPEN_DRAIN_MODE    P2MOD0|=DEF_SET_BIT1;P2MOD0|=DEF_SET_BIT0;
#define P21_OPEN_DRAIN_MODE    P2MOD0|=DEF_SET_BIT3;P2MOD0|=DEF_SET_BIT2;
#define P22_OPEN_DRAIN_MODE    P2MOD0|=DEF_SET_BIT5;P2MOD0|=DEF_SET_BIT4;
#define P23_OPEN_DRAIN_MODE    P2MOD0|=DEF_SET_BIT7;P2MOD0|=DEF_SET_BIT6;
#define P24_OPEN_DRAIN_MODE    P2MOD1|=DEF_SET_BIT1;P2MOD1|=DEF_SET_BIT0;
#define P25_OPEN_DRAIN_MODE    P2MOD1|=DEF_SET_BIT3;P2MOD1|=DEF_SET_BIT2;
#define P26_OPEN_DRAIN_MODE    P2MOD1|=DEF_SET_BIT5;P2MOD1|=DEF_SET_BIT4;
#define P27_OPEN_DRAIN_MODE    P2MOD1|=DEF_SET_BIT7;P2MOD1|=DEF_SET_BIT6;


#define SET_ALL_GPIO_OPEN_DRAIN_MODE    P0MOD0=0xff;P1MOD0=0xff;P1MOD1=0xff;P2MOD0=0xff;P2MOD1=0xff;

/************** ˿ ***********/
#define P00_PULLUP_MODE    P0PU|=DEF_SET_BIT0;
#define P01_PULLUP_MODE    P0PU|=DEF_SET_BIT1;

#define P10_PULLUP_MODE    P1PU|=DEF_SET_BIT0;
#define P11_PULLUP_MODE    P1PU|=DEF_SET_BIT1;
#define P12_PULLUP_MODE    P1PU|=DEF_SET_BIT2;
#define P13_PULLUP_MODE    P1PU|=DEF_SET_BIT3;
#define P14_PULLUP_MODE    P1PU|=DEF_SET_BIT4;
#define P15_PULLUP_MODE    P1PU|=DEF_SET_BIT5;
#define P16_PULLUP_MODE    P1PU|=DEF_SET_BIT6;
#define P17_PULLUP_MODE    P1PU|=DEF_SET_BIT7;

#define P20_PULLUP_MODE    P2PU|=DEF_SET_BIT0;
#define P21_PULLUP_MODE    P2PU|=DEF_SET_BIT1;
#define P22_PULLUP_MODE    P2PU|=DEF_SET_BIT2;
#define P23_PULLUP_MODE    P2PU|=DEF_SET_BIT3;
#define P24_PULLUP_MODE    P2PU|=DEF_SET_BIT4;
#define P25_PULLUP_MODE    P2PU|=DEF_SET_BIT5;
#define P26_PULLUP_MODE    P2PU|=DEF_SET_BIT6;
#define P27_PULLUP_MODE    P2PU|=DEF_SET_BIT7;


#define SET_ALL_GPIO_PULLUP_MODE    P0PU=0xff;P1PU=0xff;P2PU=0xff;
#define CLR_ALL_GPIO_PULLUP_MODE    P0PU=0x00;P1PU=0x00;P2PU=0x00;

/************** ˿ ***********/
#define P00_PULLDOWN_MODE    P0PD|=DEF_SET_BIT0;
#define P01_PULLDOWN_MODE    P0PD|=DEF_SET_BIT1;

#define P10_PULLDOWN_MODE    P1PD|=DEF_SET_BIT0;
#define P11_PULLDOWN_MODE    P1PD|=DEF_SET_BIT1;
#define P12_PULLDOWN_MODE    P1PD|=DEF_SET_BIT2;
#define P13_PULLDOWN_MODE    P1PD|=DEF_SET_BIT3;
#define P14_PULLDOWN_MODE    P1PD|=DEF_SET_BIT4;
#define P15_PULLDOWN_MODE    P1PD|=DEF_SET_BIT5;
#define P16_PULLDOWN_MODE    P1PD|=DEF_SET_BIT6;
#define P17_PULLDOWN_MODE    P1PD|=DEF_SET_BIT7;

#define P20_PULLDOWN_MODE    P2PD|=DEF_SET_BIT0;
#define P21_PULLDOWN_MODE    P2PD|=DEF_SET_BIT1;
#define P22_PULLDOWN_MODE    P2PD|=DEF_SET_BIT2;
#define P23_PULLDOWN_MODE    P2PD|=DEF_SET_BIT3;
#define P24_PULLDOWN_MODE    P2PD|=DEF_SET_BIT4;
#define P25_PULLDOWN_MODE    P2PD|=DEF_SET_BIT5;
#define P26_PULLDOWN_MODE    P2PD|=DEF_SET_BIT6;
#define P27_PULLDOWN_MODE    P2PD|=DEF_SET_BIT7;


#define SET_ALL_GPIO_PULLDOWN_MODE    P0PD=0xff;P1PD=0xff;P2PD=0xff;
#define CLR_ALL_GPIO_PULLDOWN_MODE    P0PD=0x00;P1PD=0x00;P2PD=0x00;
void GPIO_Init(void);

#endif
