/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *          
******************************************************************************/

#ifndef IIC_H__
#define IIC_H__

#include "user.h"

void IIC_Init(void);
void IIC_Start(uint8_t R_Slave_addr);
void IIC_Stop(void);
uint8_t IIC_Wait_Ack();
uint8_t simIIC_EEPROM_Test(void);
void IIC_Send_Byte(uint8_t data_test);
uint8_t IIC_Read_Byte(void);
void Delay(uint16_t Num);

// <<< Use Configuration Wizard in Context Menu >>>\n
// <h> SPI_Master_Slave
// <o>SPI_Master_Slave
// <i>  This is modes, 0 is Master, 1 is Slave
// <0=>  master
// <1=>  slave

#define Slave_BUFF_LEN       0x08
#define Slave_DEVICE_ADD     0xA0

// </h>
// <<< end of configuration section >>>

#endif
