/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                      SCL-P11 ; SDA-P12
******************************************************************************/

#include "IIC.h"
uint8_t temp,number_count,sr;
uint8_t iic_tx_idx,iic_status,iic_rx_idx;
uint8_t iic_tx_buffer[8],num;
uint8_t iic_rx_buffer[8];

/************************************************
;  *    @     : IIC_Init
;  *    @˵       : IICʼ
;  *    @    :
;  *    @ز    :
;  ***********************************************/
void IIC_Init(void)
{
    IICCR0 = 0xc1;           //slave modeͬ100Kbps,SCL-P11 ; SDA-P12
    IICSR = 0x00;
    IICDR = 0x00;
    IICAR = 0xA0;            //ӻַ
    IICAAR = 0x00;
    IICAMR = 0x00;
    SET_IICIE();             //ʹIICж
    IPL1 |= DEF_SET_BIT6;    //жȼ
}

void IIC_ISR(void) interrupt IIC_IRQn
{
    if(IICCR1 & 0x80) 
    {
        P13D = !P13D;
        sr = IICSR;
        IICCR1 &=~0x80; 
        FLAG_IIC_DONE = 1;
        if(F_ADDR_SAME == 0)
        {
            if(sr & 0x08)
            {
                P01D = !P01D;
                CLR_TACKS();
                F_ADDR_SAME = 1;
            }
       }
        if(F_ADDR_SAME) //ַƥɹ
        {
            switch(iic_status)
            {
                case IIC_STS_RX:  //ӻ״̬
                {
                    if((sr & 0x02)==0)
                    {
                        if(iic_rx_idx < 8)
                        {
                            CLR_TACKS();
                            iic_rx_buffer[iic_rx_idx++] = IICDR;
                        }
                    }
                    break;
                }
                case IIC_STS_TX:  //ӻ״̬
                {
                    if(sr & 0x02)
                    {
                        if(iic_tx_idx > 8)  //鳤ȷ0xff
                        {
                            IICDR = 0xff;    //
                            iic_tx_idx ++;
                        } 
                        else  //յݷ
                        {
                            IICDR = iic_rx_buffer[iic_tx_idx++];
                        }
                    }
                    else
                    {
                        iic_rx_idx = 0;
                        iic_status = IIC_STS_RX;
                    }
                    break;
                }
                case IIC_STS_BUSY://æµ
                {
                    if(sr & 0x02)
                    {
                        IICDR = 0xFF;
                    }
                    break;
                }
                case IIC_STS_IDLE://
                default:
                {
                    if(sr & 0x02)
                    {
                        IICDR = 0xFF;
                    }
                    else
                    {
                        iic_rx_idx = 0;
                        iic_status = IIC_STS_RX;
                    }
                    break;
                }
            }

        }
    }
}