/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *          
******************************************************************************/

#ifndef IIC_H__
#define IIC_H__

#include "user.h"

void IIC_Init(void);
void IIC_Slave(void);
void IIC_Slave_Write(void);

// <<< Use Configuration Wizard in Context Menu >>>\n
// <h> SPI_Master_Slave
// <o>SPI_Master_Slave
// <i>  This is modes, 0 is Master, 1 is Slave
// <0=>  master
// <1=>  slave

#define IIC_STS_IDLE 0
#define IIC_STS_RX   1
#define IIC_STS_TX   2
#define IIC_STS_BUSY 3

#define AT24C02_WORD_ADD     0x10
#define AT24C02_WR_DELAY_MS  2
#define AT24C02_DEVICE_ADD   0xA0
#define IIC_DATA_LEN         8

// </h>
// <<< end of configuration section >>>

#endif
